/*****************************  Globals   *************************************/                 
const nsGMailPOPClassID = Components.ID("{38d08a80-44a3-11da-8cd6-0800200c9a66}");
const nsGMailPOPContactID = "@mozilla.org/GMailPOP;1";
const ExtGMailGuid = "{42040a50-44a3-11da-8cd6-0800200c9a66}";

const szVersionNumber = "V20060829100000";

/******************************  GMail ***************************************/

const PatternGMailGetSessionCookie = /GMAIL_AT=(.*?);/i
const PatternGMailGetLoginCookie = /.*GX=(.*);/
const PatternGMailNewMessagesIDsStep1 = /\[\"([\da-fA-F]*)\"/g
const PatternGMailNewMessagesIDsStep2 = /\[\"([\da-fA-F]*)\"/
// const patternGMailLoginRedirect = /CheckCookie\?continue\\u003d([^"]+)/
const patternGMailLoginRedirect = /CheckCookie\?continue=(.*?)';/i

const PatternGMailRFCMsg = /X-Gmail-Received.*/;

function nsGMail()
{
    try
    {       
        var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
        scriptLoader = scriptLoader.getService(Components.interfaces.mozIJSSubScriptLoader);
        scriptLoader.loadSubScript("chrome://web-mail/content/common/DebugLog.js");
        scriptLoader.loadSubScript("chrome://web-mail/content/common/CommonPrefs.js");
        scriptLoader.loadSubScript("chrome://web-mail/content/common/comms.js");
        scriptLoader.loadSubScript("chrome://gmail/content/GMailMSG.js");

        var date = new Date();
        var szLogFileName = "GMailLog_" + date.getHours()+ "_" + date.getMinutes() + "_"+ date.getUTCMilliseconds() +"_";
	// var szLogFileName = "GMailLog_";
        this.m_Log = new DebugLog("webmail.logging.comms", ExtGMailGuid, szLogFileName); 

        this.m_Log.Write("nsGMailPOP.js " + szVersionNumber + " - Constructor - START");

	this.m_szMailURL = "https://mail.google.com/mail/"
        this.m_bAuthorised = false;
        this.m_szUserName = null;
        this.m_szPassWord = null;
        this.m_oResponseStream = null;
        this.m_HttpComms = new Comms(this , this.m_Log);
        this.m_iStage = 0; 
        this.m_szGMailAtCookie = null;
        this.m_szCookieLoginURL = null;

        this.m_aMsgDataStore = new Array();
        this.m_iTotalSize = 0;

		this.m_SessionManager = Components.classes["@mozilla.org/SessionManager;1"];
		this.m_SessionManager = this.m_SessionManager.getService();
		this.m_SessionManager.QueryInterface(Components.interfaces.nsISessionManager); 
		this.m_SessionData = null;

		//do i reuse the session
		var oPref = {Value:null};
		var  WebMailPrefAccess = new WebMailCommonPrefAccess();
		if (WebMailPrefAccess.Get("bool","gmail.bReUseSession",oPref))
			this.m_bReUseSession = oPref.Value;
		else
			this.m_bReUseSession = false; 

		this.m_Log.Write("nsGMailPOP.js - Constructor - bReUseSession : " + this.m_bReUseSession);

		//do i download unread msg only
		oPref = {Value:null};
		var  WebMailPrefAccess = new WebMailCommonPrefAccess();
		if (WebMailPrefAccess.Get("bool","gmail.bDownloadUnread",oPref))
			this.m_bDownloadUnread = oPref.Value;
		else
			this.m_bDownloadUnread = true; 
		this.m_Log.Write("nsGMailPOP.js - Constructor - bDownloadUnread : " + this.m_bDownloadUnread);

		this.m_szMsgID = 0;
		this.m_Log.Write("nsGMailPOP.js - Constructor - END");  
	}
    catch(e)
    {
        DebugDump("nsGMailPOP.js: Constructor : Exception : " 
                                      + e.name 
                                      + ".\nError message: " 
                                      + e.message);
    }
}



nsGMail.prototype =
{
    get userName() {return this.m_szUserName;},
    set userName(userName) {return this.m_szUserName = userName;},
  
    get passWord() {return this.m_szPassWord;},
    set passWord(passWord) {return this.m_szPassWord = passWord;},
    
    get bAuthorised() {return this.m_bAuthorised;},
  
    get ResponseStream() {return this.m_oResponseStream;},
    set ResponseStream(responseStream) {return this.m_oResponseStream = responseStream;},

    logIn : function()
    {
        try
        {
            this.m_Log.Write("nsGMailPOP.js - logIN - START");   
            this.m_Log.Write("nsGMailPOP.js - logIN - Username: " + this.m_szUserName
                                                   + " Password: " + this.m_szPassWord
                                                   + " stream: " + this.m_oResponseStream);

            if (!this.m_szUserName || !this.m_oResponseStream  || !this.m_szPassWord) return false;

		// get login webPage
		var loginURL = 'https://www.google.com/accounts/ServiceLoginBoxAuth';
		// var szArray = this.m_szUserName.split('@');
		// var szUsername = encodeURIComponent(szArray[0]);

		// this.m_Log.Write("nsGMailPOP.js - logIN - HELLO");

		this.m_HttpComms.clean();
		this.m_HttpComms.addRequestHeader("User-Agent", "User-Agent: Mozilla/5.0 (compatible;)", true);
		this.m_HttpComms.setContentType(0);

			this.m_SessionData = this.m_SessionManager.findSessionData(this.m_szUserName);
			if ( this.m_SessionData && this.m_bReUseSession ) {
				this.m_Log.Write("nsGMailPOP.js - logIN - Session Data found");
				this.m_HttpComms.setCookieManager(this.m_SessionData.oCookieManager);

				this.serverComms("+OK Your in\r\n");
				this.m_bAuthorised = true;
			} else {
				this.m_Log.Write("nsGMailPOP.js - logIN - No Session Data found");
				this.m_HttpComms.addValuePair('Email', encodeURIComponent(this.m_szUserName));
				this.m_HttpComms.addValuePair('Passwd', encodeURIComponent(this.m_szPassWord));
				this.m_HttpComms.addValuePair('continue', encodeURIComponent(this.m_szMailURL));

				// this.m_HttpComms.m_bHandleBounce  = false

				this.m_HttpComms.setURI(loginURL);
				this.m_HttpComms.setRequestMethod("POST");

				var bResult = this.m_HttpComms.send(this.loginOnloadHandler);
				if (!bResult) throw new Error('httpConnection returned false');
				this.m_iStage = 0;
			}

            this.m_Log.Write("nsGMailPOP.js - logIN - END");
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsGMailPOP.js: logIN : Exception : " 
                                              + e.name + 
                                              ".\nError message: " 
                                              + e.message);
            return false;
        }
    },


    loginOnloadHandler : function(szResponse ,event , mainObject)
    {
        try {
		mainObject.m_Log.Write("nsGMailPOP.js - loginOnloadHandler - START"); 
		mainObject.m_Log.Write("nsGMailPOP.js - loginOnloadHandler : " + mainObject.m_iStage);  

		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);

		//if this fails we've gone somewhere new
		mainObject.m_Log.Write("nsGMailPOP.js - loginOnloadHandler - status :" + httpChannel.responseStatus );
		if (httpChannel.responseStatus != 200) 
			throw new Error("return status " + httpChannel.responseStatus);

		switch  ( mainObject.m_iStage ) {
		case 0:
			mainObject.m_Log.Write("nsGMailPOP.js - loginOnloadHandler - redirect test");

			var aRedirect = szResponse.match(patternGMailLoginRedirect);
			if ( !aRedirect )
				throw new Error("Login failed. (Wrong username/password?)");

			var szURI = decodeURIComponent(aRedirect[1]);
			mainObject.m_Log.Write("nsGMailPOP.js - loginOnloadHandler - redirectURL " + szURI);

			mainObject.m_HttpComms.clean();
			mainObject.m_HttpComms.setContentType(0);
			mainObject.m_HttpComms.addRequestHeader("User-Agent", "User-Agent: Mozilla/5.0 (compatible;)", true);

			mainObject.m_HttpComms.setURI(szURI);
			mainObject.m_HttpComms.setRequestMethod("GET");
			var bResult = mainObject.m_HttpComms.send(mainObject.loginOnloadHandler, mainObject);
			if (!bResult) throw new Error("httpConnection returned false");

			mainObject.m_szCookieLoginURL = szURI;

			mainObject.m_iStage++;
			break;
		case 1:
	        	if ( szResponse.indexOf("Sign In") > -1 || 
					szResponse.indexOf("NewAccount") > -1 ||
					szResponse.indexOf("Username and password do not match") > -1 ||
					szResponse.indexOf("Sign up for Gmail") > -1)
				throw new Error("Invalid Password");

			var szCookies =  httpChannel.getResponseHeader("Set-Cookie");
			mainObject.m_Log.Write("nsGMailPOP.js - loginOnloadHandler - login cookies :\n" + szCookies );

			var aCookie = szCookies.match(PatternGMailGetLoginCookie);
			if ( aCookie == null)
				throw new Error("Error getting cookies during login");
			// mainObject.m_szGMailAtCookie = aCookie[1];

			mainObject.m_Log.Write("nsGMailPOP.js - loginOnloadHandler - Getting session cookie...");

			var IOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		        try {
				var nsIURI = IOService.newURI(mainObject.m_szCookieLoginURL, null, null);
			}
			catch(err) {
				mainObject.m_Log.DebugDump("nsGMailPOP.js: loginHandler : Exception : " 
                                          + err.name 
                                          + ".\nError message: " 
                                          + err.message);
				mainObject.serverComms("-ERR negative vibes (GMail)\r\n");
				break;
			}
			var oCookieManager = mainObject.m_HttpComms.getCookieManager();
			szCookies = oCookieManager.findCookie(nsIURI);
			mainObject.m_Log.Write("nsGMailPOP.js - loginOnloadHandler - session cookies:\n" + szCookies);

			mainObject.m_szGMailAtCookie = szCookies.match(PatternGMailGetSessionCookie)[1];
			if ( mainObject.m_szGMailAtCookie == null)
				throw new Error("Error getting session cookie during login");

			mainObject.m_Log.Write("nsGMailPOP.js - loginOnloadHandler - szGMAIL_AT: " + mainObject.m_szGMailAtCookie);

			if ( !mainObject.m_SessionData ) {
				mainObject.m_Log.Write("nsGMailPOP.js - loginOnloadHandler - Saving session Data");
				mainObject.m_SessionData = Components.classes["@mozilla.org/SessionData;1"].createInstance();
				mainObject.m_SessionData.QueryInterface(Components.interfaces.nsISessionData);
				mainObject.m_SessionData.szUserName = mainObject.m_szUserName;

				var componentData = Components.classes["@mozilla.org/ComponentData;1"].createInstance();
				componentData.QueryInterface(Components.interfaces.nsIComponentData);
				mainObject.m_SessionData.oComponentData = componentData;
			}
			mainObject.m_SessionData.oCookieManager = mainObject.m_HttpComms.getCookieManager();
			mainObject.m_SessionManager.setSessionData(mainObject.m_SessionData);

			mainObject.serverComms("+OK Your in\r\n");
			mainObject.m_bAuthorised = true;
			break;
		}

		mainObject.m_Log.Write("nsGMailPOP.js - loginOnloadHandler - END");
        }
        catch(err)
        {
            mainObject.m_Log.DebugDump("nsGMailPOP.js: loginHandler : Exception : " 
                                          + err.name 
                                          + ".\nError message: " 
                                          + err.message);

            mainObject.serverComms("-ERR negative vibes (GMail)\r\n");
        }
    },

    //stat
    //total size is in octets
    getNumMessages : function()
    {
        try
        {
            this.m_Log.Write("nsGMailPOP.js - getNumMessages - START"); 

		if ( this.m_bAuthorised == false )
			return false;

		var szInboxURI = this.m_szMailURL + "?search=inbox&view=tl&start=0&init=1"

		this.m_HttpComms.setURI(szInboxURI);
		this.m_HttpComms.setRequestMethod("GET");
		var bResult = this.m_HttpComms.send(this.mailBoxOnloadHandler);
		this.m_iStage = 0;

            this.m_Log.Write("nsGMailPOP.js - getNumMessages - END"); 
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsGMailPOP.js: getNumMessages : Exception : " 
                                          + e.name 
                                          + ".\nError message: " 
                                          + e.message);
            return false;
        }
    },

    mailBoxOnloadHandler : function (szResponse ,event , mainObject)
    {
        try
        {
            mainObject.m_Log.Write("nsGMailPOP.js - mailBoxOnloadHandler - START"); 

		mainObject.m_Log.Write("nsGMailPOP.js - mailBoxOnloadHandler : " + mainObject.m_iStage);
		
		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);

		//check status should be 200.
		mainObject.m_Log.Write("nsGMailPOP.js - mailBoxOnloadHandler - Mailbox :" + httpChannel.responseStatus);
		if (httpChannel.responseStatus != 200 ) 
			throw new Error("error status " + httpChannel.responseStatus);

		if ( szResponse.indexOf("in:inbox") < 0 )
			throw new Error("Error loading GMail Inbox");

		var startRawIndex = 0;
		do {
			// Get message IDs
			startRawIndex = szResponse.indexOf('D(["t",', startRawIndex);
			mainObject.m_Log.Write("nsGMailPOP.js - mailBoxOnloadHandler - startRawIndex :" + startRawIndex);
			if ( startRawIndex <0 )
				break;

			var endRawIndex= szResponse.indexOf(');',startRawIndex + 1)
			var szInboxRaws = szResponse.substring(startRawIndex + 7,endRawIndex)
			startRawIndex = endRawIndex + 1;

			var aMsgIDArray = szInboxRaws.match(PatternGMailNewMessagesIDsStep1);
			mainObject.m_Log.Write("nsGMailPOP.js - mailBoxOnloadHandler - msgArray :" + aMsgIDArray);
			if ( !aMsgIDArray )
				break;

			var iNum = aMsgIDArray.length;
			mainObject.m_Log.Write("nsGMailPOP.js - mailBoxOnloadHandler - msgNum :" + iNum);
	
			for (i = 0; i <  iNum ; i++ ) {
				var szAString = aMsgIDArray[i];
				var anID = szAString.match(PatternGMailNewMessagesIDsStep2)[1];
				mainObject.m_Log.Write("nsGMailPOP.js - mailBoxOnloadHandler - anID DEC:" + anID);
	
				var data = new GMailMSG();
				data.szMsgID = anID;
		
				//
				// TODO 
				// GMail does not provide the message size, so we return a fake one until
				// we find a nice way of retriving the info
				//
				var iSize = 100000;
		
				mainObject.m_Log.Write("nsGMailPOP.js - getNumMessages - Debug :" + anID + " - " + iSize);
			
				data.iSize = iSize;
				mainObject.m_iTotalSize += iSize;
				mainObject.m_aMsgDataStore.push(data);
			}
		} while ( true );

		mainObject.serverComms("+OK "+ mainObject.m_aMsgDataStore.length + " " + mainObject.m_iTotalSize + "\r\n");

            mainObject.m_Log.Write("nsGMailPOP.js - MailBoxOnload - END"); 
        }
        catch(err)
        {
             mainObject.m_Log.DebugDump("nsGMailPOP.js: MailboxOnload : Exception : " 
                                              + err.name 
                                              + ".\nError message: " 
                                              + err.message);

             mainObject.serverComms("-ERR negative vibes (GMail)\r\n");
        }
    },

    //list
    //I'm not downloading the mailbox again. 
    //I hope stat been called first or there's going to be trouble
    getMessageSizes : function() 
    {
	try
	{
		this.m_Log.Write("nsGMailPOP.js - getMessageSizes - START"); 

		if ( this.m_bAuthorised == false )
			return false;

		var szPOPResponse = "+OK " + this.m_aMsgDataStore.length + " Messages\r\n"; 
		this.m_Log.Write("nsGMailPOP.js - getMessagesSizes - : " + this.m_aMsgDataStore.length);

		for (i = 0; i <  this.m_aMsgDataStore.length; i++) {
			var data = this.m_aMsgDataStore[i];
			var iEmailSize = data.iSize;
			szPOPResponse+=(i+1) + " " + iEmailSize + "\r\n";
		}

		szPOPResponse += ".\r\n";

		this.serverComms(szPOPResponse);

		this.m_Log.Write("nsGMailPOP.js - getMessageSizes - END"); 
		return true;
	}
	catch(e)
	{
		this.m_Log.DebugDump("nsGMailPOP.js: getMessageSizes : Exception : " 
					+ e.name 
					+ ".\nError message: " 
					+ e.message);
		return false;
	}
    },

    //IUDL
    getMessageIDs : function()
    {
	try
	{
		this.m_Log.Write("nsGMailPOP.js - getMessageIDs - START");

		if ( this.m_bAuthorised == false )
			return false;

		var szPOPResponse = "+OK " + this.m_aMsgDataStore.length + " Messages\r\n";
		this.m_Log.Write("nsGMailPOP.js - getMessageIDs - return : " + this.m_aMsgDataStore.length ); 

		for (i = 0; i <  this.m_aMsgDataStore.length; i++) {
			var data = this.m_aMsgDataStore[i];
			var szEmailID = data.szMsgID;
			szPOPResponse+=(i+1) + " " + szEmailID + "\r\n";
		}

		szPOPResponse += ".\r\n";
		this.serverComms(szPOPResponse);

		this.m_Log.Write("nsGMailPOP.js - getMessageIDs - END");
		return true;
	}
	catch(e)
	{
		this.m_Log.DebugDump("nsGMailPOP.js: getMessageIDs : Exception : "
                                          + e.name
                                          + ".\nError message: "
                                          + e.message);
		return false;
	}
    },

    //retr
    getMessage : function(msgIndex)
    {
        try
        {
		this.m_Log.Write("nsGMailPOP.js - getMessage - START"); 

		if ( this.m_bAuthorised == false )
			return false;

		//get msg id
		var oMSGData = this.m_aMsgDataStore[msgIndex-1]
		this.m_szMsgID = oMSGData.szMsgID;
		this.m_Log.Write("nsGMailPOP.js - getMessage - msg id: " + this.m_szMsgID); 

		var getMsgParams = 'q=in%3Aanywhere&start=0&search=query&view=om' + '&th=' + this.m_szMsgID;
		var szInboxURI = this.m_szMailURL + '?' + getMsgParams;

		this.m_iStage = 0;
		this.m_HttpComms.clean();
		this.m_HttpComms.setURI(szInboxURI);
		this.m_HttpComms.setRequestMethod("GET");
		var bResult = this.m_HttpComms.send(this.emailOnloadHandler); 
		if (!bResult) throw new Error("httpConnection returned false");

		this.m_Log.Write("nsGMailPOP.js - getMessage - END"); 
		return true;
        }
        catch(e)
        {
             this.m_Log.DebugDump("nsGMailPOP.js: getMessage : Exception : " 
                                          + e.name + 
                                          ".\nError message: " 
                                          + e.message);
            return false;
        }
    },


    emailOnloadHandler : function (szResponse ,event , mainObject)
    {
        try
        {
		mainObject.m_Log.Write("nsGMailPOP.js - emailOnloadHandler - START");
		mainObject.m_Log.Write("nsGMailPOP.js - emailOnloadHandler - msg :\n" + szResponse); 

		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);
		//check status should be 200.
		if (httpChannel.responseStatus != 200) 
			throw new Error("error status " + httpChannel.responseStatus);

		mainObject.m_HttpComms.clean();
		mainObject.m_HttpComms.setContentType(0);

		// if ( szResponse.indexOf('X-Gmail-Received') < 0 )
		// if ( szResponse.indexOf('Subject:') < 0 )
		if ( szResponse.indexOf('From:') < 0 )
			throw new Error("Unexpected reply from GMail; " + szResponse);

		var szMsg =  "X-WebMail: true\r\n";
		szMsg += szResponse;
		szMsg += "\r\n.\r\n";  //msg end 

		var szPOPResponse = "+OK " + szMsg.length + "\r\n";
		szPOPResponse += szMsg;
		mainObject.serverComms(szPOPResponse);

		mainObject.m_Log.Write("nsGMailPOP.js - emailOnloadHandler - END");      
        }
        catch(err)
        {
		mainObject.m_Log.DebugDump("nsGMailPOP.js: emailOnloadHandler : Exception : " 
                                          + err.name 
                                          + ".\nError message: " 
                                          + err.message);
		mainObject.serverComms("-ERR negative vibes (GMail)\r\n");
        }
    },

    //dele
    deleteMessage : function(msgIndex)
    {
        try
        {
            this.m_Log.Write("nsGMailPOP.js - deleteMessage - START");

		if ( this.m_bAuthorised == false )
			return false;

		//get msg id
		var oMSGData = this.m_aMsgDataStore[msgIndex-1]
		this.m_szMsgID = oMSGData.szMsgID;
		this.m_Log.Write("nsGMailPOP.js - deleteMessage - msg id: " + this.m_szMsgID);

		this.m_HttpComms.clean();
		this.m_HttpComms.addValuePair('search', 'inbox');
		this.m_HttpComms.addValuePair('view', 'tl');
		this.m_HttpComms.addValuePair('start', '0');
		this.m_HttpComms.addValuePair('at', this.m_szGMailAtCookie);
		this.m_HttpComms.addValuePair('act', 'tr');
		this.m_HttpComms.addValuePair('t', this.m_szMsgID);

		var szDeleteMsgURL = this.m_szMailURL;

		this.m_HttpComms.setURI(szDeleteMsgURL);
		this.m_HttpComms.setRequestMethod("POST");

		var bResult = this.m_HttpComms.send(this.deleteMessageOnloadHandler);
		this.m_iStage = 0;

            this.m_Log.Write("nsGMailPOP.js - deleteMessage - END");
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsGMailPOP.js: deleteMessage : Exception : " 
                                          + e.name + 
                                          ".\nError message: " 
                                          + e.message);
            return false;
        } 
    },


    deleteMessageOnloadHandler : function (szResponse ,event , mainObject)
    {
        try
        {
		mainObject.m_Log.Write("nsGMailPOP.js - deleteMessageOnload - START");    

		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);
		//check status should be 200.
		mainObject.m_Log.Write("nsGMailPOP.js - deleteMessageOnload :" + httpChannel.responseStatus);
		if (httpChannel.responseStatus != 200 ) 
			throw new Error("error status " + httpChannel.responseStatus);   

/*
		if ( szResponse.indexOf("The conversation has been moved to the Trash") < 0 )
			throw new Error("Error deleting message);
*/

		mainObject.serverComms("+OK its history\r\n");      
		mainObject.m_Log.Write("nsGMailPOP.js - deleteMessageOnload - END");      
        }
        catch(e)
        {
		mainObject.m_Log.DebugDump("nsGMailPOP.js: deleteMessageOnload : Exception : " + e.name
                                              + ".\nError message: " 
                                              + e.message);
		mainObject.serverComms("-ERR negative vibes (GMail)\r\n");
        }
    },

    //cookies are deleted when the connection ends so i dont need to download pages
    logOut : function()
    {
        try
        {
            this.m_Log.Write("nsGMailPOP.js - logOUT - START"); 
/*
    var ios = Components.classes[kIOSERVICE_CONTRACTID].getService(nsIIOService);
    var cookieMgr = Components.classes[kCOOKIESERVICE_CONTRACTID].getService(nsICookieManager);
    cookieMgr.remove("mail.google.com", "GX", "/mail", false); cookieMgr.remove(".google.com", "SID", "/", false);
*/
            this.m_bAuthorised = false;
            this.serverComms("+OK Your Out\r\n");

            this.m_Log.Write("nsGMailPOP.js - logOUT - END");  
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsGMailPOP.js: logOUT : Exception : " 
                                      + e.name 
                                      + ".\nError message: " 
                                      + e.message);
            return false;
        }
    },  

    serverComms : function (szMsg)
    {
        try
        { 
            this.m_Log.Write("nsGMailPOP.js - serverComms - START");
            this.m_Log.Write("nsGMailPOP.js - serverComms msg " + szMsg);
            var iCount = this.m_oResponseStream.write(szMsg,szMsg.length);
            this.m_Log.Write("nsGMailPOP.js - serverComms sent count: " + iCount +" msg length: " +szMsg.length);
            this.m_Log.Write("nsGMailPOP.js - serverComms - END");  
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsGMailPOP.js: serverComms : Exception : " 
                                              + e.name 
                                              + ".\nError message: " 
                                              + e.message);
        }
    },
   
   
/******************************************************************************/
/***************** XPCOM  stuff ***********************************************/
/******************************************************************************/
    QueryInterface : function (iid)
    {
        if (!iid.equals(Components.interfaces.nsIPOPDomainHandler) 
        	                      	&& !iid.equals(Components.interfaces.nsISupports))
            throw Components.results.NS_ERROR_NO_INTERFACE;
            
        return this;
    }
}
 

/******************************************************************************/
/* FACTORY*/
var nsGMailFactory = new Object();

nsGMailFactory.createInstance = function (outer, iid)
{
    if (outer != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
    
    if (!iid.equals(nsGMailPOPClassID) && !iid.equals(Components.interfaces.nsISupports))
        throw Components.results.NS_ERROR_INVALID_ARG;
    
    return new nsGMail();
}


/******************************************************************************/
/* MODULE */
var nsGMailModule = new Object();

nsGMailModule.registerSelf = function(compMgr, fileSpec, location, type)
{
    compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    compMgr.registerFactoryLocation(nsGMailPOPClassID,
                                    "GMailComponent",
                                    nsGMailPOPContactID, 
                                    fileSpec,
                                    location,
                                    type);
}


nsGMailModule.unregisterSelf = function(aCompMgr, aFileSpec, aLocation)
{
    aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(nsGMailPOPClassID, aFileSpec);
}

 
nsGMailModule.getClassObject = function(compMgr, cid, iid)
{
    if (!cid.equals(nsGMailPOPClassID))
        throw Components.results.NS_ERROR_NO_INTERFACE;

    if (!iid.equals(Components.interfaces.nsIFactory))
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    return nsGMailFactory;
}


nsGMailModule.canUnload = function(compMgr)
{
    return true;
}
/******************************************************************************/


function NSGetModule(compMgr, fileSpec)
{
    return nsGMailModule; 
}
